extends Node2D

export var initial_lives=3
export var coins_per_live=5
var lives
var coins=0
var timer
var inbound_portal
onready var total_coins=get_tree().get_nodes_in_group("COINS").size();

func _ready():
	Global.GameState=self
	lives=initial_lives
	update_ui()
	$Sounds/Music.play()
	call_deferred("inbound_portal_setup")

func inbound_portal_setup():
	var inbound_portal=load(Global.ScenePortal).instance()
	inbound_portal.disable()
	inbound_portal.global_position=Global.Player.global_position
	self.add_child(inbound_portal)
	inbound_portal.vanish()

func update_ui():
	Global.UI.update_ui(lives,coins)

func hurt():
	lives-=1
	Global.UI.live_down()
	update_ui()
	Global.Player.hurt()
	if lives<0:
		game_over()

func live_up():
	lives+=1
	Global.UI.live_up()
	Global.ExtraLive_sfx.play()
	update_ui()

func coin_up():
	coins+=1
	Global.UI.coin_up()
	Global.Coin_sfx.play()
	if (coins%coins_per_live)==0:
		live_up()
	else:
		update_ui()

func game_over():
	change_scene(Global.SceneGameOver)

func victory():
	change_scene(Global.SceneVictory)

func change_scene(new_scene):
	Global.last_level_coins_no=total_coins
	Global.last_level_coins_collected=coins
	get_tree().change_scene(new_scene)