extends KinematicBody2D

const SPEED=750
const GRAVITY=2500
const JUMP_SPEED=-1500
const JUMP_BOOST=1.5
const JUMP_TIMER_STOP=300
const UP=Vector2(0,-1)
var motion=Vector2()
var flag_jump_just_queued=false

export var level_bottom=3000

func _ready():
	Global.Player=self

func _physics_process(delta):
	prepare_movement(delta)
	move_and_slide(motion,UP)

func _process(delta):
	$AnimatedSprite.update(motion)
	check_game_over()

func prepare_movement(delta):
	if is_on_floor():
		$TimerAllowJump.start()
	elif motion.y>JUMP_TIMER_STOP or motion.y<-JUMP_TIMER_STOP:
		$TimerAllowJump.stop()
	fall(delta)
	run()
	jump()

func fall(delta):
	if flag_jump_just_queued:
		flag_jump_just_queued=false
	elif !is_on_floor() and !is_on_ceiling():
		motion.y+=GRAVITY*delta
	else:
		motion.y=0

func run():
	if Input.is_action_pressed("ui_right") and not Input.is_action_pressed("ui_left"):
		motion.x=SPEED
	elif Input.is_action_pressed("ui_left") and not Input.is_action_pressed("ui_right"):
		motion.x=-SPEED
	else:
		motion.x=0

func jump():
	if $TimerAllowJump.time_left>0 and Input.is_action_pressed("ui_up"):
		$TimerAllowJump.stop()
		motion.y+=JUMP_SPEED
		flag_jump_just_queued=true
		Global.Jump_sfx.play()

func boost():
	motion.y=JUMP_SPEED*JUMP_BOOST
	flag_jump_just_queued=true
	Global.Boost_sfx.play()


func check_game_over():
	if position.y>level_bottom:
		Global.GameState.game_over()

func hurt():
	motion.y=JUMP_SPEED
	flag_jump_just_queued=true
	Global.Hurt_sfx.play()
	$AnimatedSprite.hurt()
